-- phpMyAdmin SQL Dump
-- version 4.2.12deb2
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Mar 01, 2016 alle 19:33
-- Versione del server: 5.5.46-0+deb7u1
-- PHP Version: 5.6.7-1

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `ludo`
--

-- --------------------------------------------------------

--
-- Struttura della tabella `causaVoltaggio`
--

CREATE TABLE IF NOT EXISTS `causaVoltaggio` (
`idCausaVoltaggio` int(11) NOT NULL,
  `descrizione` varchar(45) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `configurazioneVisualizzazioneSensori`
--

CREATE TABLE IF NOT EXISTS `configurazioneVisualizzazioneSensori` (
`idConfigurazione` int(11) NOT NULL,
  `idUtente` int(11) NOT NULL,
  `idDispositivo` int(11) NOT NULL,
  `idSensore` int(11) NOT NULL,
  `posizione` tinyint(4) NOT NULL,
  `tipologiaVisualizzazione` varchar(50) DEFAULT 'tempo-reale'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `dispositivi`
--

CREATE TABLE IF NOT EXISTS `dispositivi` (
`idDispositivo` int(11) NOT NULL,
  `descrizioneDispositivo` varchar(255) NOT NULL,
  `luogoDispositivo` varchar(255) NOT NULL,
  `accessori` varchar(255) DEFAULT NULL,
  `firmware` varchar(255) DEFAULT NULL
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COMMENT='LIsta dei dispositivi Arduino utilizzati';

-- --------------------------------------------------------

--
-- Struttura della tabella `inputAnalogico`
--

CREATE TABLE IF NOT EXISTS `inputAnalogico` (
`idInputAnalogico` int(11) NOT NULL,
  `idDispositivo` int(11) NOT NULL,
  `idSensore` int(11) NOT NULL,
  `idCausaVoltaggio` int(11) NOT NULL,
  `valoreInputAnalogico` int(11) NOT NULL,
  `data` datetime DEFAULT NULL,
  `dataServer` datetime NOT NULL,
  `informazioni` varchar(45) DEFAULT NULL,
  `ip` varchar(15) DEFAULT NULL,
  `macaddress` varchar(17) DEFAULT NULL
) ENGINE=InnoDB AUTO_INCREMENT=22076 DEFAULT CHARSET=utf8 COMMENT='Tabella che serve per memorizzare i dati che provengono da un sensore per il rilevamento del voltaggio in corrente continua.\nI valori possono essere digitali: 0 se non c''è tensione, 1 se c''è tensione\noppure analogici: 0 minimo, 1023 massimo.';

-- --------------------------------------------------------

--
-- Struttura della tabella `inputDigitale`
--

CREATE TABLE IF NOT EXISTS `inputDigitale` (
`idInputDigitale` int(11) NOT NULL,
  `idDispositivo` int(11) NOT NULL,
  `idSensore` int(11) NOT NULL,
  `idCausaVoltaggio` int(11) NOT NULL,
  `valoreInputDigitale` tinyint(1) NOT NULL,
  `data` datetime DEFAULT NULL,
  `dataServer` datetime NOT NULL,
  `informazioni` varchar(45) DEFAULT NULL,
  `ip` varchar(15) DEFAULT NULL,
  `macaddress` varchar(17) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Tabella che serve per memorizzare i dati cheprovengono da un sensore per il rilevamento del voltaggio in corrente alternata.';

-- --------------------------------------------------------

--
-- Struttura della tabella `pressioneAtmosferica`
--

CREATE TABLE IF NOT EXISTS `pressioneAtmosferica` (
`idPressioneAtmosferica` int(11) NOT NULL,
  `idDispositivo` int(11) NOT NULL,
  `idSensore` int(11) NOT NULL,
  `pressioneAtmosferica` float NOT NULL,
  `data` datetime DEFAULT NULL,
  `dataServer` datetime NOT NULL,
  `informazioni` varchar(255) DEFAULT NULL,
  `ip` varchar(15) DEFAULT NULL,
  `macaddress` varchar(17) DEFAULT NULL
) ENGINE=InnoDB AUTO_INCREMENT=7365 DEFAULT CHARSET=utf8 COMMENT='Memorizza i dati provenienti da un sensore per la pressione atmosferica';

-- --------------------------------------------------------

--
-- Struttura della tabella `sensori`
--

CREATE TABLE IF NOT EXISTS `sensori` (
`idSensore` int(11) NOT NULL,
  `nomeSensore` varchar(45) NOT NULL,
  `descrizioneSensore` varchar(255) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8 COMMENT='LIsta dei sensori Arduino utilizzati';

-- --------------------------------------------------------

--
-- Struttura della tabella `temperatura`
--

CREATE TABLE IF NOT EXISTS `temperatura` (
`idTemperatura` int(11) NOT NULL,
  `idDispositivo` int(11) NOT NULL,
  `idSensore` int(11) NOT NULL,
  `temperatura` float NOT NULL,
  `temperaturaPercepita` float DEFAULT NULL,
  `data` datetime DEFAULT NULL,
  `dataServer` datetime NOT NULL,
  `informazioni` varchar(255) DEFAULT NULL,
  `ip` varchar(15) DEFAULT NULL,
  `macaddress` varchar(17) DEFAULT NULL
) ENGINE=InnoDB AUTO_INCREMENT=14729 DEFAULT CHARSET=utf8 COMMENT='Memorizza i dati provenienti da un sensore di temperatura';

-- --------------------------------------------------------

--
-- Struttura della tabella `testDispositivi`
--

CREATE TABLE IF NOT EXISTS `testDispositivi` (
`idTestDispositivo` int(11) NOT NULL,
  `idDispositivo` int(11) NOT NULL,
  `idDispositivoControllato` int(11) NOT NULL,
  `esito` tinyint(1) NOT NULL,
  `esitoDescrizione` varchar(255) NOT NULL,
  `dataServer` datetime NOT NULL,
  `ip` varchar(15) DEFAULT NULL,
  `macaddress` varchar(17) DEFAULT NULL,
  `informazioni` varchar(255) DEFAULT NULL
) ENGINE=InnoDB AUTO_INCREMENT=1510 DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `umidita`
--

CREATE TABLE IF NOT EXISTS `umidita` (
`idUmidita` int(11) NOT NULL,
  `idDispositivo` int(11) NOT NULL,
  `idSensore` int(11) NOT NULL,
  `umidita` float NOT NULL,
  `data` datetime DEFAULT NULL,
  `dataServer` datetime NOT NULL,
  `informazioni` varchar(255) DEFAULT NULL,
  `ip` varchar(15) DEFAULT NULL,
  `macaddress` varchar(17) DEFAULT NULL
) ENGINE=InnoDB AUTO_INCREMENT=7365 DEFAULT CHARSET=utf8 COMMENT='Memorizza i dati provenienti da un sensore di umidità';

-- --------------------------------------------------------

--
-- Struttura della tabella `utenti`
--

CREATE TABLE IF NOT EXISTS `utenti` (
`idUtente` int(11) NOT NULL,
  `email` varchar(100) NOT NULL,
  `nome` varchar(50) DEFAULT NULL,
  `cognome` varchar(50) DEFAULT NULL,
  `password` varchar(50) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

--
-- Indexes for dumped tables
--

--
-- Indexes for table `causaVoltaggio`
--
ALTER TABLE `causaVoltaggio`
 ADD PRIMARY KEY (`idCausaVoltaggio`);

--
-- Indexes for table `configurazioneVisualizzazioneSensori`
--
ALTER TABLE `configurazioneVisualizzazioneSensori`
 ADD PRIMARY KEY (`idConfigurazione`), ADD KEY `fk_configurazioni_utenti_idx` (`idUtente`), ADD KEY `fk_configurazioni_sensori_idx` (`idSensore`), ADD KEY `fk_configurazioneVisualizzazioneSensori_dispositivi_idx` (`idDispositivo`);

--
-- Indexes for table `dispositivi`
--
ALTER TABLE `dispositivi`
 ADD PRIMARY KEY (`idDispositivo`);

--
-- Indexes for table `inputAnalogico`
--
ALTER TABLE `inputAnalogico`
 ADD PRIMARY KEY (`idInputAnalogico`), ADD KEY `fk_inputAnalogico_sensori_idx` (`idSensore`), ADD KEY `fk_inputAnalogico_dispositivi_idx` (`idDispositivo`), ADD KEY `fk_inputAnalogico_causaVoltaggio_idx` (`idCausaVoltaggio`);

--
-- Indexes for table `inputDigitale`
--
ALTER TABLE `inputDigitale`
 ADD PRIMARY KEY (`idInputDigitale`), ADD KEY `fk_inputDigitale_sensori_idx` (`idSensore`), ADD KEY `fk_inputDigitale_dispositivi_idx` (`idDispositivo`), ADD KEY `fk_inputDigitale_causaVoltaggio_idx` (`idCausaVoltaggio`);

--
-- Indexes for table `pressioneAtmosferica`
--
ALTER TABLE `pressioneAtmosferica`
 ADD PRIMARY KEY (`idPressioneAtmosferica`), ADD KEY `fk_pressioneAtmosferica_dispositivi_idx` (`idDispositivo`), ADD KEY `fk_pressioneAtmosferica_sensori_idx` (`idSensore`);

--
-- Indexes for table `sensori`
--
ALTER TABLE `sensori`
 ADD PRIMARY KEY (`idSensore`);

--
-- Indexes for table `temperatura`
--
ALTER TABLE `temperatura`
 ADD PRIMARY KEY (`idTemperatura`), ADD KEY `fk_temperatura_dispositivi_idx` (`idDispositivo`), ADD KEY `fk_temperatura_sensori_idx` (`idSensore`);

--
-- Indexes for table `testDispositivi`
--
ALTER TABLE `testDispositivi`
 ADD PRIMARY KEY (`idTestDispositivo`), ADD KEY `fk_testDispositivi_dispositivi_idx` (`idDispositivo`), ADD KEY `fk_testDispositivi_dispositivi2_idx` (`idDispositivoControllato`);

--
-- Indexes for table `umidita`
--
ALTER TABLE `umidita`
 ADD PRIMARY KEY (`idUmidita`), ADD KEY `fk_umidita_dispositivi_idx` (`idDispositivo`), ADD KEY `fk_umidita_sensori_idx` (`idSensore`);

--
-- Indexes for table `utenti`
--
ALTER TABLE `utenti`
 ADD PRIMARY KEY (`idUtente`), ADD UNIQUE KEY `email_UNIQUE` (`email`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `causaVoltaggio`
--
ALTER TABLE `causaVoltaggio`
MODIFY `idCausaVoltaggio` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=4;
--
-- AUTO_INCREMENT for table `configurazioneVisualizzazioneSensori`
--
ALTER TABLE `configurazioneVisualizzazioneSensori`
MODIFY `idConfigurazione` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `dispositivi`
--
ALTER TABLE `dispositivi`
MODIFY `idDispositivo` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=7;
--
-- AUTO_INCREMENT for table `inputAnalogico`
--
ALTER TABLE `inputAnalogico`
MODIFY `idInputAnalogico` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=22076;
--
-- AUTO_INCREMENT for table `inputDigitale`
--
ALTER TABLE `inputDigitale`
MODIFY `idInputDigitale` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `pressioneAtmosferica`
--
ALTER TABLE `pressioneAtmosferica`
MODIFY `idPressioneAtmosferica` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=7365;
--
-- AUTO_INCREMENT for table `sensori`
--
ALTER TABLE `sensori`
MODIFY `idSensore` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=12;
--
-- AUTO_INCREMENT for table `temperatura`
--
ALTER TABLE `temperatura`
MODIFY `idTemperatura` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=14729;
--
-- AUTO_INCREMENT for table `testDispositivi`
--
ALTER TABLE `testDispositivi`
MODIFY `idTestDispositivo` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1510;
--
-- AUTO_INCREMENT for table `umidita`
--
ALTER TABLE `umidita`
MODIFY `idUmidita` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=7365;
--
-- AUTO_INCREMENT for table `utenti`
--
ALTER TABLE `utenti`
MODIFY `idUtente` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=3;
--
-- Limiti per le tabelle scaricate
--

--
-- Limiti per la tabella `configurazioneVisualizzazioneSensori`
--
ALTER TABLE `configurazioneVisualizzazioneSensori`
ADD CONSTRAINT `fk_configurazioni_utenti` FOREIGN KEY (`idUtente`) REFERENCES `utenti` (`idUtente`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_configurazioni_sensori` FOREIGN KEY (`idSensore`) REFERENCES `sensori` (`idSensore`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_configurazioneVisualizzazioneSensori_dispositivi` FOREIGN KEY (`idDispositivo`) REFERENCES `dispositivi` (`idDispositivo`) ON DELETE NO ACTION ON UPDATE NO ACTION;

--
-- Limiti per la tabella `inputAnalogico`
--
ALTER TABLE `inputAnalogico`
ADD CONSTRAINT `fk_inputAnalogico_causaVoltaggio` FOREIGN KEY (`idCausaVoltaggio`) REFERENCES `causaVoltaggio` (`idCausaVoltaggio`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_inputAnalogico_dispositivi` FOREIGN KEY (`idDispositivo`) REFERENCES `dispositivi` (`idDispositivo`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_inputAnalogico_sensori` FOREIGN KEY (`idSensore`) REFERENCES `sensori` (`idSensore`) ON DELETE NO ACTION ON UPDATE NO ACTION;

--
-- Limiti per la tabella `inputDigitale`
--
ALTER TABLE `inputDigitale`
ADD CONSTRAINT `fk_inputDigitale_causaVoltaggio` FOREIGN KEY (`idCausaVoltaggio`) REFERENCES `causaVoltaggio` (`idCausaVoltaggio`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_inputDigitale_dispositivi` FOREIGN KEY (`idDispositivo`) REFERENCES `dispositivi` (`idDispositivo`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_inputDigitale_sensori` FOREIGN KEY (`idSensore`) REFERENCES `sensori` (`idSensore`) ON DELETE NO ACTION ON UPDATE NO ACTION;

--
-- Limiti per la tabella `pressioneAtmosferica`
--
ALTER TABLE `pressioneAtmosferica`
ADD CONSTRAINT `fk_pressioneAtmosferica_dispositivi` FOREIGN KEY (`idDispositivo`) REFERENCES `dispositivi` (`idDispositivo`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_pressioneAtmosferica_sensori` FOREIGN KEY (`idSensore`) REFERENCES `sensori` (`idSensore`) ON DELETE NO ACTION ON UPDATE NO ACTION;

--
-- Limiti per la tabella `temperatura`
--
ALTER TABLE `temperatura`
ADD CONSTRAINT `fk_temperatura_dispositivi` FOREIGN KEY (`idDispositivo`) REFERENCES `dispositivi` (`idDispositivo`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_temperatura_sensori` FOREIGN KEY (`idSensore`) REFERENCES `sensori` (`idSensore`) ON DELETE NO ACTION ON UPDATE NO ACTION;

--
-- Limiti per la tabella `testDispositivi`
--
ALTER TABLE `testDispositivi`
ADD CONSTRAINT `fk_testDispositivi_dispositivi` FOREIGN KEY (`idDispositivo`) REFERENCES `dispositivi` (`idDispositivo`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_testDispositivi_dispositivi2` FOREIGN KEY (`idDispositivoControllato`) REFERENCES `dispositivi` (`idDispositivo`) ON DELETE NO ACTION ON UPDATE NO ACTION;

--
-- Limiti per la tabella `umidita`
--
ALTER TABLE `umidita`
ADD CONSTRAINT `fk_umidita_dispositivi` FOREIGN KEY (`idDispositivo`) REFERENCES `dispositivi` (`idDispositivo`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_umidita_sensori` FOREIGN KEY (`idSensore`) REFERENCES `sensori` (`idSensore`) ON DELETE NO ACTION ON UPDATE NO ACTION;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
