<?php
include "ut.php";
testLogged();

/* inizializzo le variabili */
$dataInizio = null;               // Se è impostata la query parte dalle rivelazioni effettuate da questa data, altrimenti parte da 30 giorno fa
$dataFine = null;                 // Se è impostata la query arriva alle rivelazioni effettuate fino a questa data, altrimenti arriva fino ad oggi
$temperaturaDTH = null;           // Se è impostata a 1 viene visualizzato il grafico con le rilevazioni della temperatura fatte dal sensore DTH
$temperaturaPercepitaDTH = null;  // Se è impostata a 1 viene visualizzato il grafico con le rilevazioni della temperatura fatte dal sensore BMP180
$temperaturaBMP = null;           // Se è impostata a 1 viene visualizzato il grafico con le rilevazioni della temperatura percepita fatte dal sensore DTH

$urlToGetJasonData = "getJsonData.php?0=0";

/* recupero le variabili dalla richiesta */
if (isset($_GET['dataInizio'])) {
	$dataInizio = htmlspecialchars($_GET["dataInizio"]);
	$urlToGetJasonData .= "&dataInizio=$dataInizio";
}
if (isset($_GET['dataFine'])) {
	$dataFine = htmlspecialchars($_GET["dataFine"]);
	$urlToGetJasonData .= "&dataFine=$dataFine";
}
if (isset($_GET['temperaturaDTH'])) {
	$temperaturaDTH = htmlspecialchars($_GET["temperaturaDTH"]);
	$urlToGetJasonData .= "&temperaturaDTH=$temperaturaDTH";
}
if (isset($_GET['temperaturaPercepitaDTH'])) {
	$temperaturaPercepitaDTH = htmlspecialchars($_GET["temperaturaPercepitaDTH"]);
	$urlToGetJasonData .= "&temperaturaPercepitaDTH=$temperaturaPercepitaDTH";
}
if (isset($_GET['temperaturaBMP'])) {
	$temperaturaBMP = htmlspecialchars($_GET["temperaturaBMP"]);
	$urlToGetJasonData .= "&temperaturaBMP=$temperaturaBMP";
}


?>

<html>
  <head>
    <!--Load the AJAX API-->
    <script type="text/javascript" src="https://www.google.com/jsapi"></script>
    <script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>
    
	 <!--Load the Visualization API and the piechart package.-->
    <!--
    <script type="text/javascript"
          src="https://www.google.com/jsapi?autoload={
            'modules':[{
              'name':'visualization',
              'version':'1',
              'packages':['corechart']
            }]
          }">
    </script>
    -->

    <script type="text/javascript">
    	google.load('visualization', '1', {'packages':['corechart']});
      google.setOnLoadCallback(drawChart);


      function drawChart() {
      
        var jsonData = $.ajax({
          url: "<?=$urlToGetJasonData ?>",
          dataType: "json",
          async: false
          }).responseText;
          
        // Create our data table out of JSON data loaded from server.
        var data = new google.visualization.DataTable(jsonData);

        var options = {
          title: 'Informazioni temperatura casa',
          curveType: 'function',
          legend: { position: 'right' },
          interpolateNulls: true,
          width: 900,
          height: 500
        };
			
		// Instantiate and draw our chart, passing in some options.
      var chart = new google.visualization.LineChart(document.getElementById('curve_chart'));

        chart.draw(data, options);
      }
    </script>
  </head>
  <body>
    <div id="curve_chart" style="width: 900px; height: 500px"></div>
  </body>
</html>

