<?php

error_reporting(E_ALL);
ini_set('display_errors', 1);

//MySQL Database Connect
require_once 'dbInfo.php';

/* File per il log */
$file = "text.txt";

/* inizializzo le variabili */
$dataInizio = null;            // Se è impostata la query parte dalle rivelazioni effettuate da questa data, altrimenti parte da 30 giorno fa
$dataFine = null;              // Se è impostata la query arriva alle rivelazioni effettuate fino a questa data, altrimenti arriva fino ad oggi
$temperaturaDTH = 0;           // Se è impostata a 1 viene visualizzato il grafico con le rilevazioni della temperatura fatte dal sensore DTH
$temperaturaPercepitaDTH = 0;  // Se è impostata a 1 viene visualizzato il grafico con le rilevazioni della temperatura fatte dal sensore BMP180
$temperaturaBMP = 0;           // Se è impostata a 1 viene visualizzato il grafico con le rilevazioni della temperatura percepita fatte dal sensore DTH

/* recupero le variabili dalla richiesta */
if (isset($_GET['dataInizio'])) {
	$dataInizio = htmlspecialchars($_GET["dataInizio"]);
}
if (isset($_GET['dataFine'])) {
	$dataFine = htmlspecialchars($_GET["dataFine"]);
}
if (isset($_GET['temperaturaDTH'])) {
	$temperaturaDTH = htmlspecialchars($_GET["temperaturaDTH"]);
}
if (isset($_GET['temperaturaPercepitaDTH'])) {
	$temperaturaPercepitaDTH = htmlspecialchars($_GET["temperaturaPercepitaDTH"]);
}
if (isset($_GET['temperaturaBMP'])) {
	$temperaturaBMP = htmlspecialchars($_GET["temperaturaBMP"]);
}

/* Controllo le variabili e se non sono definite faccio delle impostazioni di base */
if ($temperaturaDTH != 1 && $temperaturaPercepitaDTH != 1 && $temperaturaBMP != 1 ) {
	$temperaturaDTH = 1;
	$temperaturaPercepitaDTH = 1;
	$temperaturaBMP = 1;
}
if ($dataFine == null) {
	// $dataFine = date("Y-m-d H:i:s");  // 2001-03-10 17:16:18 (the MySQL DATETIME format)
	$dataFine = date("Y-m-d"); // data attuale
	//echo $dataFine . "<br><br>";
}
if ($dataInizio == null) {
	$dataInizio = date('Y-m-d', strtotime('-30 days')); // get the 30 days ago date in PHP
	//echo $dataInizio . "<br><br>";
}
//$dataInizio = "2016-01-01";
//$dataFine = "2016-01-05";

$dataInizio .= " 00:00:01";
$dataFine .= " 23:59:59";


/* Costruisco la query sql */
$sql = "SELECT idTemperatura, idDispositivo, idSensore, temperatura, temperaturaPercepita, data, dataserver, ip FROM temperatura";
$sql .= " WHERE 1=1";
if ($dataInizio != null) {
	$sql .= " AND data >= '$dataInizio'";
}
if ($dataFine != null) {
	$sql .= " AND data <= '$dataFine'";
}
$sql .= " ORDER BY idTemperatura";
$sql .= " DESC";
//$sql .= " LIMIT 1000";


/*
$arr2 = array(
            "cols" => array(
                          array("id" => "A","label" => "Data"                ,"pattern" => "","type" => "string"),
                          array("id" => "B","label" => "TemperaturaDHT"      ,"pattern" => "","type" => "number"),
                          array("id" => "C","label" => "TemperaturaBMP180"   ,"pattern" => "","type" => "number"),
                          array("id" => "D","label" => "TemperaturaPercepita","pattern" => "","type" => "number")
                      )
        );
*/

/*      
$arr1 = array(
            "cols" => array( 
                          array("id" => "A","label" => "Data"                ,"pattern" => "","type" => "string")
                      )
        );
*/

/* Costruisco l'array dalla query per utilizzarlo per generare il json da inviare come risposta */
$arr1 = array();
$arr1["cols"] = array();
$arr1["cols"][0] = array("id" => "A","label" => "Data"                ,"pattern" => "","type" => "string");

/*
$arr1["cols"][0][] = array("id" => "B","label" => "TemperaturaDHT"      ,"pattern" => "","type" => "number");
$arr1["cols"][0][] = array("id" => "C","label" => "TemperaturaBMP180"   ,"pattern" => "","type" => "number");
$arr1["cols"][0][] = array("id" => "D","label" => "TemperaturaPercepita","pattern" => "","type" => "number");
*/

if ($temperaturaDTH == 1) {
	$arr1["cols"][] = array("id" => "B","label" => "TempDHT"      ,"pattern" => "","type" => "number");
}
if ($temperaturaBMP == 1) {
	$arr1["cols"][] = array("id" => "C","label" => "TempBMP180"   ,"pattern" => "","type" => "number");
}
if ($temperaturaPercepitaDTH == 1) {
	$arr1["cols"][] = array("id" => "D","label" => "TempPercepita","pattern" => "","type" => "number");
}

/* Mi connetto al DB ed eseguo la query */
try {
	$conn = new PDO("mysql:host=$servername;dbname=$database", $username, $password);
   // set the PDO error mode to exception
	$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);                      
	$stmt = $conn->prepare($sql); 
	$stmt->execute();
	// set the resulting array to associative
	$resultSetFetch = $stmt->setFetchMode(PDO::FETCH_ASSOC);
	$result = $stmt->fetchAll();
	//print_r($result);

	$reversed = array_reverse($result);
	
	
	foreach($reversed as $keyNumero => $valueArrayRiga) {
   	//echo $key . "-" . $value . "<br/>";
		//print_r($valueArrayRiga);
		//echo "<br>";
		//echo "idSensore= " . $valueArrayRiga['idSensore'] . " data= " . $valueArrayRiga['data'] . " temperatura= " . $valueArrayRiga['temperatura'];
		//echo "<br><br>";
		$temperaturaDB = $valueArrayRiga['temperatura'];
		$temperaturaPercepitaDB = $valueArrayRiga['temperaturaPercepita'];
		$dataDB = $valueArrayRiga['dataserver'];
		$sensoreDB = $valueArrayRiga['idSensore'];
		
		$arrayTemp = array();
   	if ($sensoreDB == 1) {
   		//                                             data rilevamento                   temperatura DHT                                                           temperatura DHT percepita
   		//$arrayTemp = array( "c" => array( array("v" => $dataDB,"f" => null), array("v" => $temperaturaDB,"f" => null), array("v" => null,"f" => null), array("v" => $temperaturaPercepitaDB,"f" => null) ) );
   		$arrayTemp["c"] = array();
   		$arrayTemp["c"][] = array("v" => $dataDB,"f" => null);
   		if ($temperaturaDTH == 1) {
   			$arrayTemp["c"][] = array("v" => $temperaturaDB,"f" => null);
   		}
    		if ($temperaturaBMP == 1) {
   			$arrayTemp["c"][] = array("v" => null,"f" => null);
   		}
    		if ($temperaturaPercepitaDTH == 1) {
   			$arrayTemp["c"][] = array("v" => $temperaturaPercepitaDB,"f" => null);
   		}   
   	} else if ($sensoreDB == 2) {
			//                                             data rilevamento                                                   temperatura BMP180
   		//$arrayTemp = array( "c" => array( array("v" => $dataDB,"f" => null), array("v" => null,"f" => null), array("v" => $temperaturaDB,"f" => null), array("v" => null,"f" => null) ) );
   		$arrayTemp["c"] = array();
   		$arrayTemp["c"][] = array("v" => $dataDB,"f" => null);
   		if ($temperaturaDTH == 1) {
   			$arrayTemp["c"][] = array("v" => null,"f" => null);
   		}
    		if ($temperaturaBMP == 1) {
   			$arrayTemp["c"][] = array("v" => $temperaturaDB,"f" => null);
   		}
    		if ($temperaturaPercepitaDTH == 1) {
   			$arrayTemp["c"][] = array("v" => null,"f" => null);
   		} 		
   		
   	}
   	$arr1["rows"][] = $arrayTemp;
	}

	$conn = null;
} catch(PDOException $e) {
  	echo $sql . "<br>" . $e->getMessage();
	$Saved_File = fopen($file, 'a');
	fwrite($Saved_File, $sql . "\r\n" . $e->getMessage());
	fclose($Saved_File);
}

/*
print_r($arr2);
echo "<br>";echo "<br>";
print_r($arr1);
echo "<br>";echo "<br>";echo "<br>";echo "<br>";
*/

/* Genero il codice json (partendo dall'arrray) da inviare come risposta */
echo json_encode($arr1);




?>
