<?php
	/*
	 * Dati serie storica.
	 * Questo file (ancora non ho scritto tutte le sue funzionalità) 
	 * recupera dal database le serie storiche dei dati raccolti dai sensori:
	 * temperatura, pressione, umidità
	 * e li restituisce in Json
	 * (per ora ci sono solo le temperature di alcuni sensori)
	 */
// 	require_once '../util/session.php'; // lo devo attivare (problemi dipath)
	
	//MySQL Database Connect
	require_once '../util/database.php';
	
	/* Variabili per il log */
	$logFile = "../logs/logGetData.txt"; // file per il log
	$dataServer = date("Y-m-d H:i:s");
	$nomeFilePhp = basename($_SERVER['REQUEST_URI'], '?' . $_SERVER['QUERY_STRING']); // recupera il nome di questo file PHP dall'URL
	$nomeFilePhp .= " - getJsonDataFromDb.php";
	
	$Saved_File = fopen($logFile, 'a');
	fwrite($Saved_File,  "------------------------------------------------------------------------------------\r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - " . print_r($_GET, true) . "\r\n");
	fclose($Saved_File);
	
	/* inizializzo le variabili */
	$dataInizio = null;            // Se è questa variabile impostata, la query parte dalle rivelazioni effettuate da questa data, altrimenti parte da 30 giorno fa
	$dataFine = null;              // Se è questa variabile impostata, la query arriva alle rivelazioni effettuate fino a questa data, altrimenti arriva fino ad oggi
	$temperaturaDTH = 0;           // Se è questa variabile è impostata a 1 allora viene visualizzato il grafico con le rilevazioni della temperatura fatte dal sensore DTH
	$temperaturaPercepitaDTH = 0;  // Se è questa variabile è impostata a 1 allora viene visualizzato il grafico con le rilevazioni della temperatura percepita fatte dal sensore DTH
	$temperaturaBMP = 0;           // Se è questa variabile è impostata a 1 allora viene visualizzato il grafico con le rilevazioni della temperatura fatte dal sensore BMP180
	$umiditaDTH = 0;               // Se è questa variabile è impostata a 1 allora viene visualizzato il grafico con le rilevazioni dell'umidita fatte dal sensore DTH
	$pressioneBMP = 0;             // Se è questa variabile è impostata a 1 allora viene visualizzato il grafico con le rilevazioni della pressione fatte dal sensore BMP180
	/*
	 * Nota bene:
	 * questo file restituisce i dati di un solo tipo:
	 * prima controlla se sono richiesti i dati della temperatura, se sono rchiesti li restituisce
	 * se non sono richiesti i dati della temperatura allora controlla se sono richiesti i dati dell'umidità, se sono rchiesti li restituisce
	 * se non sono richiesti i dati dell'umidità allora controlla se sono richiesti i dati della presione, se sono rchiesti li restituisce
	 * 
	 */
	
	/* recupero le variabili dalla richiesta */
	if (isset($_GET['dataInizio'])) {
		$dataInizio = htmlspecialchars($_GET["dataInizio"]);
	}
	if (isset($_GET['dataFine'])) {
		$dataFine = htmlspecialchars($_GET["dataFine"]);
	}
	if (isset($_GET['temperaturaDTH'])) {
		$temperaturaDTH = htmlspecialchars($_GET["temperaturaDTH"]);
	}
	if (isset($_GET['temperaturaPercepitaDTH'])) {
		$temperaturaPercepitaDTH = htmlspecialchars($_GET["temperaturaPercepitaDTH"]);
	}
	if (isset($_GET['temperaturaBMP'])) {
		$temperaturaBMP = htmlspecialchars($_GET["temperaturaBMP"]);
	}
	if (isset($_GET['umiditaDTH'])) {
		$umiditaDTH = htmlspecialchars($_GET["umiditaDTH"]);
	}
	if (isset($_GET['pressioneBMP'])) {
		$pressioneBMP = htmlspecialchars($_GET["pressioneBMP"]);
	}
	
	/* Controllo le variabili e se non sono definite faccio delle impostazioni di base */
	if ($temperaturaDTH != 1 && $temperaturaPercepitaDTH != 1 && $temperaturaBMP != 1 && $umiditaDTH!=1 && $pressioneBMP!=1) {
		$temperaturaDTH = 1;
		$temperaturaPercepitaDTH = 1;
		$temperaturaBMP = 1;
	}
	if ($dataFine == null) {
		// $dataFine = date("Y-m-d H:i:s");  // 2001-03-10 17:16:18 (the MySQL DATETIME format)
		$dataFine = date("Y-m-d"); // data attuale
		//echo $dataFine . "<br><br>";
	}
	if ($dataInizio == null) {
		$dataInizio = date('Y-m-d', strtotime('-30 days')); // get the 30 days ago date in PHP
		//echo $dataInizio . "<br><br>";
	}
	//$dataInizio = "2016-01-01";
	//$dataFine = "2016-01-05";
	
	$dataInizio .= " 00:00:01";
	$dataFine .= " 23:59:59";
	
	$arr1 = array(); // array che contiene il json da restituire come risposta
	
	
	if ($temperaturaDTH == 1 || $temperaturaPercepitaDTH == 1 || $temperaturaBMP == 1) {
		/* Costruisco la query sql */
		$sql = "SELECT idTemperatura, idDispositivo, idSensore, temperatura, temperaturaPercepita, data, dataserver, ip FROM temperatura";
		$sql .= " WHERE 1=1";
		if ($dataInizio != null) {
			$sql .= " AND data >= '$dataInizio'";
		}
		if ($dataFine != null) {
			$sql .= " AND data <= '$dataFine'";
		}
		$sql .= " ORDER BY idTemperatura";
		$sql .= " DESC";
		//$sql .= " LIMIT 1000";
		
		
		/*
		 $arr2 = array(
		 "cols" => array(
		 array("id" => "A","label" => "Data"                ,"pattern" => "","type" => "string"),
		 array("id" => "B","label" => "TemperaturaDHT"      ,"pattern" => "","type" => "number"),
		 array("id" => "C","label" => "TemperaturaBMP180"   ,"pattern" => "","type" => "number"),
		 array("id" => "D","label" => "TemperaturaPercepita","pattern" => "","type" => "number")
		 )
		 );
		 */
		
		/*
		 $arr1 = array(
		 "cols" => array(
		 array("id" => "A","label" => "Data"                ,"pattern" => "","type" => "string")
		 )
		 );
		 */
		
		/* Costruisco l'array dalla query per utilizzarlo per generare il json da inviare come risposta */
		$arr1["cols"] = array();
		$arr1["cols"][0] = array("id" => "A","label" => "Data"                ,"pattern" => "","type" => "string");
		
		/*
		 $arr1["cols"][0][] = array("id" => "B","label" => "TemperaturaDHT"      ,"pattern" => "","type" => "number");
		 $arr1["cols"][0][] = array("id" => "C","label" => "TemperaturaBMP180"   ,"pattern" => "","type" => "number");
		 $arr1["cols"][0][] = array("id" => "D","label" => "TemperaturaPercepita","pattern" => "","type" => "number");
		 */
		
	// 	if ($temperaturaDTH == 1) {
	// 		$arr1["cols"][] = array("id" => "B","label" => "TempDHT"      ,"pattern" => "","type" => "number");
	// 	}
	// 	if ($temperaturaBMP == 1) {
	// 		$arr1["cols"][] = array("id" => "C","label" => "TempBMP180"   ,"pattern" => "","type" => "number");
	// 	}
	// 	if ($temperaturaPercepitaDTH == 1) {
	// 		$arr1["cols"][] = array("id" => "D","label" => "TempPercepita","pattern" => "","type" => "number");
	// 	}
	
		if ($temperaturaDTH == 1) {
			$arr1["cols"][] = array("id" => "B","label" => "T. sala"      ,"pattern" => "","type" => "number");
		}
		if ($temperaturaBMP == 1) {
			$arr1["cols"][] = array("id" => "C","label" => "T. Studio"   ,"pattern" => "","type" => "number");
		}
		if ($temperaturaPercepitaDTH == 1) {
			$arr1["cols"][] = array("id" => "D","label" => "T. sala percepita","pattern" => "","type" => "number");
		}
		
		/* Mi connetto al DB ed eseguo la query */
		try {
			//$conn = new PDO("mysql:host=$dbHost;$dbName=$database", $dbUsername, $dbUserPassword);
			$conn = Database::connect();
			// set the PDO error mode to exception
			$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			$stmt = $conn->prepare($sql);
			$stmt->execute();
			// set the resulting array to associative
			$resultSetFetch = $stmt->setFetchMode(PDO::FETCH_ASSOC);
			$result = $stmt->fetchAll();
			//print_r($result);
		
			$reversed = array_reverse($result);
		
		
			foreach($reversed as $keyNumero => $valueArrayRiga) {
				//echo $key . "-" . $value . "<br/>";
				//print_r($valueArrayRiga);
				//echo "<br>";
				//echo "idSensore= " . $valueArrayRiga['idSensore'] . " data= " . $valueArrayRiga['data'] . " temperatura= " . $valueArrayRiga['temperatura'];
				//echo "<br><br>";
				$temperaturaDB = $valueArrayRiga['temperatura'];
				$temperaturaPercepitaDB = $valueArrayRiga['temperaturaPercepita'];
				$dataDB = $valueArrayRiga['dataserver'];
				$sensoreDB = $valueArrayRiga['idSensore'];
		
				$arrayTemp = array();
				if ($sensoreDB == 1) {
					//                                             data rilevamento                   temperatura DHT                                                           temperatura DHT percepita
					//$arrayTemp = array( "c" => array( array("v" => $dataDB,"f" => null), array("v" => $temperaturaDB,"f" => null), array("v" => null,"f" => null), array("v" => $temperaturaPercepitaDB,"f" => null) ) );
					$arrayTemp["c"] = array();
					$arrayTemp["c"][] = array("v" => $dataDB,"f" => null);
					if ($temperaturaDTH == 1) {
						$arrayTemp["c"][] = array("v" => $temperaturaDB,"f" => null);
					}
					if ($temperaturaBMP == 1) {
						$arrayTemp["c"][] = array("v" => null,"f" => null);
					}
					if ($temperaturaPercepitaDTH == 1) {
						$arrayTemp["c"][] = array("v" => $temperaturaPercepitaDB,"f" => null);
					}
				} else if ($sensoreDB == 2) {
					//                                             data rilevamento                                                   temperatura BMP180
					//$arrayTemp = array( "c" => array( array("v" => $dataDB,"f" => null), array("v" => null,"f" => null), array("v" => $temperaturaDB,"f" => null), array("v" => null,"f" => null) ) );
					$arrayTemp["c"] = array();
					$arrayTemp["c"][] = array("v" => $dataDB,"f" => null);
					if ($temperaturaDTH == 1) {
						$arrayTemp["c"][] = array("v" => null,"f" => null);
					}
					if ($temperaturaBMP == 1) {
						$arrayTemp["c"][] = array("v" => $temperaturaDB,"f" => null);
					}
					if ($temperaturaPercepitaDTH == 1) {
						$arrayTemp["c"][] = array("v" => null,"f" => null);
					}
					 
				}
				$arr1["rows"][] = $arrayTemp;
			}
		
			Database::disconnect();
		} catch(PDOException $e) {
			echo $sql . "<br>" . $e->getMessage();
			$Saved_File = fopen($file, 'a');
			fwrite($Saved_File, $sql . "\r\n" . $e->getMessage());
			fclose($Saved_File);
		}
	} else if ($umiditaDTH == 1) { // if ($temperaturaDTH == 1 || $temperaturaPercepitaDTH == 1 || $temperaturaBMP == 1)
		/* Costruisco la query sql */
		$sql = "SELECT idUmidita, idDispositivo, idSensore, umidita, data, dataserver, ip FROM umidita";
		$sql .= " WHERE 1=1";
		if ($dataInizio != null) {
			$sql .= " AND data >= '$dataInizio'";
		}
		if ($dataFine != null) {
			$sql .= " AND data <= '$dataFine'";
		}
		$sql .= " ORDER BY idUmidita";
		$sql .= " DESC";
		
		/* Costruisco l'array dalla query per utilizzarlo per generare il json da inviare come risposta */
		$arr1["cols"] = array();
		$arr1["cols"][0] = array("id" => "A","label" => "Data"                ,"pattern" => "","type" => "string");
		
		$arr1["cols"][] = array("id" => "B","label" => "U. sala"      ,"pattern" => "","type" => "number");
		
		/* Mi connetto al DB ed eseguo la query */
		try {
			//$conn = new PDO("mysql:host=$dbHost;$dbName=$database", $dbUsername, $dbUserPassword);
			$conn = Database::connect();
			// set the PDO error mode to exception
			$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			$stmt = $conn->prepare($sql);
			$stmt->execute();
			// set the resulting array to associative
			$resultSetFetch = $stmt->setFetchMode(PDO::FETCH_ASSOC);
			$result = $stmt->fetchAll();
			//print_r($result);
		
			$reversed = array_reverse($result);
		
		
			foreach($reversed as $keyNumero => $valueArrayRiga) {
				//echo $key . "-" . $value . "<br/>";
				//print_r($valueArrayRiga);
				//echo "<br>";
				//echo "idSensore= " . $valueArrayRiga['idSensore'] . " data= " . $valueArrayRiga['data'] . " temperatura= " . $valueArrayRiga['temperatura'];
				//echo "<br><br>";
				$umiditaDB = $valueArrayRiga['umidita'];
				$dataDB = $valueArrayRiga['dataserver'];
				$sensoreDB = $valueArrayRiga['idSensore'];
		
				$arrayTemp = array();
				if ($sensoreDB == 1) {
					//                                             data rilevamento                   temperatura DHT                                                           temperatura DHT percepita
					//$arrayTemp = array( "c" => array( array("v" => $dataDB,"f" => null), array("v" => $temperaturaDB,"f" => null), array("v" => null,"f" => null), array("v" => $temperaturaPercepitaDB,"f" => null) ) );
					$arrayTemp["c"] = array();
					$arrayTemp["c"][] = array("v" => $dataDB,"f" => null);
					$arrayTemp["c"][] = array("v" => $umiditaDB,"f" => null);
				}
				$arr1["rows"][] = $arrayTemp;
			}
		
			Database::disconnect();
		} catch(PDOException $e) {
			echo $sql . "<br>" . $e->getMessage();
			$Saved_File = fopen($file, 'a');
			fwrite($Saved_File, $sql . "\r\n" . $e->getMessage());
			fclose($Saved_File);
		}
	} else if ($pressioneBMP == 1) { // if ($umiditaDTH == 1)
		/* Costruisco la query sql */
		$sql = "SELECT idPressioneAtmosferica, idDispositivo, idSensore, pressioneAtmosferica, data, dataserver, ip FROM pressioneAtmosferica";
		$sql .= " WHERE 1=1";
		if ($dataInizio != null) {
			$sql .= " AND data >= '$dataInizio'";
		}
		if ($dataFine != null) {
			$sql .= " AND data <= '$dataFine'";
		}
		$sql .= " ORDER BY idPressioneAtmosferica";
		$sql .= " DESC";
		
		/* Costruisco l'array dalla query per utilizzarlo per generare il json da inviare come risposta */
		$arr1["cols"] = array();
		$arr1["cols"][0] = array("id" => "A","label" => "Data"                ,"pattern" => "","type" => "string");
		
		$arr1["cols"][] = array("id" => "B","label" => "P. sala"      ,"pattern" => "","type" => "number");
		
		/* Mi connetto al DB ed eseguo la query */
		try {
			//$conn = new PDO("mysql:host=$dbHost;$dbName=$database", $dbUsername, $dbUserPassword);
			$conn = Database::connect();
			// set the PDO error mode to exception
			$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			$stmt = $conn->prepare($sql);
			$stmt->execute();
			// set the resulting array to associative
			$resultSetFetch = $stmt->setFetchMode(PDO::FETCH_ASSOC);
			$result = $stmt->fetchAll();
			//print_r($result);
		
			$reversed = array_reverse($result);
		
		
			foreach($reversed as $keyNumero => $valueArrayRiga) {
				//echo $key . "-" . $value . "<br/>";
				//print_r($valueArrayRiga);
				//echo "<br>";
				//echo "idSensore= " . $valueArrayRiga['idSensore'] . " data= " . $valueArrayRiga['data'] . " temperatura= " . $valueArrayRiga['temperatura'];
				//echo "<br><br>";
				$pressioneBMP = $valueArrayRiga['pressioneAtmosferica'];
				$dataDB = $valueArrayRiga['dataserver'];
				$sensoreDB = $valueArrayRiga['idSensore'];
		
				$arrayTemp = array();
				if ($sensoreDB == 2) {
					//                                             data rilevamento                   temperatura DHT                                                           temperatura DHT percepita
					//$arrayTemp = array( "c" => array( array("v" => $dataDB,"f" => null), array("v" => $temperaturaDB,"f" => null), array("v" => null,"f" => null), array("v" => $temperaturaPercepitaDB,"f" => null) ) );
					$arrayTemp["c"] = array();
					$arrayTemp["c"][] = array("v" => $dataDB,"f" => null);
					$arrayTemp["c"][] = array("v" => $pressioneBMP,"f" => null);
// 					echo "pressioneBMP= $pressioneBMP\r\n";
				}
				$arr1["rows"][] = $arrayTemp;
			}
		
			Database::disconnect();
		} catch(PDOException $e) {
			echo $sql . "<br>" . $e->getMessage();
			$Saved_File = fopen($file, 'a');
			fwrite($Saved_File, $sql . "\r\n" . $e->getMessage());
			fclose($Saved_File);
		}
	}
	
	/*
	 print_r($arr2);
	 echo "<br>";echo "<br>";
	 print_r($arr1);
	 echo "<br>";echo "<br>";echo "<br>";echo "<br>";
	 */
	
	/* Genero il codice json (partendo dall'arrray) da inviare come risposta */
	echo json_encode($arr1);
	
	
	
	
	?>
		