<?php

/*
 * Dati in tempo reale.
 * Questo file recupera l'ultima lettura dal DB
 * dei dati rilevati dai seguenti sensori in tempo reale:
 * temperatura
 * e li restituisce in Json:
 * posso scegliere tra il formato adatto per essere utilizzato direttamente con Google Charts
 * e un formato più semplice da utilizzare negli altri casi
 * Devo indicare da quale dispositivo (e da quale sensore)
 * voglio leggere la temperatura
 * 
 *
 */

//MySQL Database Connect
require_once '../util/database.php';

/* Variabili per il log */
$logFile = "../logs/logGetData.txt"; // file per il log
$dataServer = date("Y-m-d H:i:s");
$nomeFilePhp = basename($_SERVER['REQUEST_URI'], '?' . $_SERVER['QUERY_STRING']); // recupera il nome del file PHP dall'URL


$tabella = "temperatura";
$jsonFormat = "GoogleChart"; // seleziono il formato json da utilzzare: "GoogleChart" o "simple"
if (isset($_GET['jsonFormat'])) {
	$jsonFormat = $_GET["jsonFormat"];
}
$idDispositivo = 1; // 
if (isset($_GET['idDispositivo'])) {
	$idDispositivo = $_GET["idDispositivo"];
}
$idSensore1 = 1; //
if (isset($_GET['idSensore1'])) {
	$idSensore1 = $_GET["idSensore1"];
}
$idSensore2 = 2; //
if (isset($_GET['idSensore2'])) {
	$idSensore2 = $_GET["idSensore2"];
}

/* Costruisco la query sql */
$sql1 = "SELECT idTemperatura, idDispositivo, idSensore, temperatura, temperaturaPercepita, data, dataserver, ip FROM $tabella";
$sql1 .= " WHERE idDispositivo=$idDispositivo AND idSensore=$idSensore1";
$sql1 .= " ORDER BY idTemperatura";
$sql1 .= " DESC";
$sql1 .= " LIMIT 1";

$sql2 = "SELECT idTemperatura, idDispositivo, idSensore, temperatura, temperaturaPercepita, data, dataserver, ip FROM $tabella";
$sql2 .= " WHERE idDispositivo=$idDispositivo AND idSensore=$idSensore2";
$sql2 .= " ORDER BY idTemperatura";
$sql2 .= " DESC";
$sql2 .= " LIMIT 1";

/* Costruisco l'array dalla query per utilizzarlo per generare il json da inviare come risposta */
$arr1 = array();
$arr1["cols"] = array();
$arr1["cols"][] = array("label" => "Label","type" => "string");
$arr1["cols"][] = array("label" => "Value","type" => "number");
//$arr1["cols"][] = array("id" => "A","label" => "TempDTH","pattern" => "","type" => "number");
//$arr1["cols"][] = array("id" => "B","label" => "TempPerc","pattern" => "","type" => "number");
//$arr1["cols"][] = array("id" => "B","label" => "TempBMP","pattern" => "","type" => "number");

// in questo array metto i dati in un formato json più semplice di quello per Google Charts, in modo da utilizzarlo per altre applicazioni 
$arrSimple= array();

try {
	//$conn = new PDO("mysql:host=$servername;dbname=$database", $username, $password);
	/* Mi connetto al DB ed eseguo la query */
	$conn = Database::connect();
	// set the PDO error mode to exception
	$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	$stmt = $conn->prepare($sql1);
	$stmt->execute();
	// set the resulting array to associative
	$resultSetFetch = $stmt->setFetchMode(PDO::FETCH_ASSOC);
	$result = $stmt->fetchAll();
	//print_r($result);

	foreach($result as $keyNumero => $valueArrayRiga) {
		//echo $key . "-" . $value . "<br/>";
		//print_r($valueArrayRiga);
		//echo "<br>";
		//echo "idSensore= " . $valueArrayRiga['idSensore'] . " data= " . $valueArrayRiga['data'] . " temperatura= " . $valueArrayRiga['temperatura'];
		//echo "<br><br>";
		$temperaturaDB = $valueArrayRiga['temperatura'];
// 		$temperaturaPercepitaDB = $valueArrayRiga['temperaturaPercepita'];

		$arrayTemp1 = array();
		$arrayTemp2 = array();
		//                                             data rilevamento                   temperatura DHT                                                           temperatura DHT percepita
		//$arrayTemp = array( "c" => array( array("v" => $dataDB,"f" => null), array("v" => $temperaturaDB,"f" => null), array("v" => null,"f" => null), array("v" => $temperaturaPercepitaDB,"f" => null) ) );
		$arrayTemp1["c"] = array();
// 		$arrayTemp1["c"][] = array("v" => 'TempDTH');
		$arrayTemp1["c"][] = array("v" => '°C');
		$arrayTemp1["c"][] = array("v" => $temperaturaDB);
		$arrayTemp2["c"] = array();
// 		$arrayTemp2["c"][] = array("v" => 'TempPerc');
// 		$arrayTemp2["c"][] = array("v" => $temperaturaPercepitaDB);
		$arr1["rows"][] = $arrayTemp1;
// 		$arr1["rows"][] = $arrayTemp2;
		
		$arrSimple["TempDTH"] = $temperaturaDB;
// 		$arrSimple["TempPerc"] = $temperaturaPercepitaDB;
	}

	$stmt2 = $conn->prepare($sql2);
	$stmt2->execute();
	// set the resulting array to associative
	$resultSetFetch2 = $stmt2->setFetchMode(PDO::FETCH_ASSOC);
	$result2 = $stmt2->fetchAll();
	//print_r($result);

	foreach($result2 as $keyNumero => $valueArrayRiga) {
		//echo $key . "-" . $value . "<br/>";
		//print_r($valueArrayRiga);
		//echo "<br>";
		//echo "idSensore= " . $valueArrayRiga['idSensore'] . " data= " . $valueArrayRiga['data'] . " temperatura= " . $valueArrayRiga['temperatura'];
		//echo "<br><br>";
		$temperaturaDB = $valueArrayRiga['temperatura'];

		$arrayTemp = array();
		//                                             data rilevamento                   temperatura DHT                                                           temperatura DHT percepita
		//$arrayTemp = array( "c" => array( array("v" => $dataDB,"f" => null), array("v" => $temperaturaDB,"f" => null), array("v" => null,"f" => null), array("v" => $temperaturaPercepitaDB,"f" => null) ) );
		$arrayTemp["c"] = array();
// 		$arrayTemp["c"][] = array("v" => 'TempBMP');
		$arrayTemp["c"][] = array("v" => '°C');
		$arrayTemp["c"][] = array("v" => $temperaturaDB);
		$arr1["rows"][] = $arrayTemp;
		
		$arrSimple["TempBMP"] = $temperaturaDB;
	}

	$Saved_File = fopen($logFile, 'a');
	fwrite($Saved_File,  "------------------------------------------------------------------------------------\r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - " . print_r($_GET, true) . "\r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - Chiamata effettuata: \r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - " . print_r($arr1, true) . "\r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - Chiamata effettuata simple: \r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - " . print_r($arrSimple, true) . "\r\n");
	fclose($Saved_File);
	//$conn = null;
	Database::disconnect();
} catch(PDOException $e) {
	print_r($arr1) . "<br>" . $e->getMessage();
	$Saved_File = fopen($logFile, 'a');
	fwrite($Saved_File,  "$dataServer - $nomeFilePhp - " . $e->getMessage() . "\r\n");
	fclose($Saved_File);
}

/*
 print_r($arr2);
 echo "<br>";echo "<br>";
 print_r($arr1);
 echo "<br>";echo "<br>";echo "<br>";echo "<br>";
 */

/* Genero il codice json (partendo dall'arrray) da inviare come risposta */
if ($jsonFormat=="simple") {
	echo json_encode($arrSimple);;
} else {
	echo json_encode($arr1);
}



