<?php

/*
 * Dati in tempo reale.
 * Questo file recupera la data dell'ultima lettura dal DB
 * dei dati rilevati dal sensore che viene passato in GET
 * e la restituisce in Json
 *
 */

//MySQL Database Connect
require_once '../util/database.php';

/* Variabili per il log */
$logFile = "../logs/logGetData.txt"; // file per il log
$dataServer = date("Y-m-d H:i:s");
$nomeFilePhp = basename($_SERVER['REQUEST_URI'], '?' . $_SERVER['QUERY_STRING']); // recupera il nome del file PHP dall'URL

$tabella = "temperatura";
$jsonFormat = "GoogleChart"; // seleziono il formato json da utilzzare: "GoogleChart" o "simple"
if (isset($_GET['jsonFormat'])) {
	$jsonFormat = $_GET["jsonFormat"];
}
$idDispositivo = 1; //
if (isset($_GET['idDispositivo'])) {
	$idDispositivo = $_GET["idDispositivo"];
}
$idSensore1 = 1; //
if (isset($_GET['idSensore1'])) {
	$idSensore1 = $_GET["idSensore1"];
}
$tipoRilevamento = 1; //
if (isset($_GET['tipoRilevamento'])) {
	$tipoRilevamento = $_GET["tipoRilevamento"];
}

/* Costruisco la query sql */
$sql1 = "SELECT MAX(dataserver) as dataserver FROM $tipoRilevamento";
$sql1 .= " WHERE idDispositivo=$idDispositivo AND idSensore=$idSensore1";
// $sql1 .= " ORDER BY idTemperatura";
// $sql1 .= " DESC";
// $sql1 .= " LIMIT 1";

// echo "sql= " . $sql1 . "<br>";


/* Costruisco l'array dalla query per utilizzarlo per generare il json da inviare come risposta */
$arr1 = array();

// in questo array metto i dati in un formato json più semplice di quello per Google Charts, in modo da utilizzarlo per altre applicazioni
$arrSimple= array();

/* Mi connetto al DB ed eseguo le query */
try {
	//$conn = new PDO("mysql:host=$servername;dbname=$database", $username, $password);
	$conn = Database::connect();
	// set the PDO error mode to exception
	$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
	$stmt = $conn->prepare($sql1);
	$stmt->execute();
	// set the resulting array to associative
	$resultSetFetch = $stmt->setFetchMode(PDO::FETCH_ASSOC);
	$result = $stmt->fetchAll();
	//print_r($result);

	foreach($result as $keyNumero => $valueArrayRiga) {
		//echo $key . "-" . $value . "<br/>";
		//print_r($valueArrayRiga);
		//echo "<br>";
		//echo "idSensore= " . $valueArrayRiga['idSensore'] . " data= " . $valueArrayRiga['data'] . " temperatura= " . $valueArrayRiga['temperatura'];
		//echo "<br><br>";
		$dataserverDB = $valueArrayRiga['dataserver'];

		$arr1["date"] = $dataserverDB;
		
		$arrSimple["date"] = $dataserverDB;
	}



	$Saved_File = fopen($logFile, 'a');
	fwrite($Saved_File,  "------------------------------------------------------------------------------------\r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - " . print_r($_GET, true) . "\r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - sql: \r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - " . print_r($sql1, true) . "\r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - Chiamata effettuata: \r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - " . print_r($arr1, true) . "\r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - Chiamata effettuata simple: \r\n");
	fwrite($Saved_File, "$dataServer - $nomeFilePhp - " . print_r($arrSimple, true) . "\r\n");
	fclose($Saved_File);
	//$conn = null;
	Database::disconnect();
} catch(PDOException $e) {
	print_r($arr1) . "<br>" . $e->getMessage();
	$Saved_File = fopen($logFile, 'a');
	fwrite($Saved_File,  "$dataServer - $nomeFilePhp - " . $e->getMessage() . "\r\n");
	fclose($Saved_File);
}

/*
 print_r($arr2);
 echo "<br>";echo "<br>";
 print_r($arr1);
 echo "<br>";echo "<br>";echo "<br>";echo "<br>";
 */

/* Genero il codice json (partendo dall'arrray) da inviare come risposta */
if ($jsonFormat=="simple") {
	echo json_encode($arrSimple);;
} else {
	echo json_encode($arr1);
}




?>


