<?php

/*
 * Dati in serie storica.
 * Questo file mostra la serie storica 
 * dei dati rilevati dai seguenti sensori in tempo reale:
 * temperatura
 * Devo indicare da quale dispositivo (e da quale sensore) 
 * voglio leggere la temperatura
 * 
 */
// require_once '../util/session.php';

/* Variabili per il log */
$logFile = "logs/logGetData.txt"; // file per il log
$dataServer = date("Y-m-d H:i:s");
$nomeFilePhp = basename($_SERVER['REQUEST_URI'], '?' . $_SERVER['QUERY_STRING']); // recupera il nome di questo file PHP dall'URL
$nomeFilePhp .= " - showDataPressureHistorical.php";

$Saved_File = fopen($logFile, 'a');
fwrite($Saved_File,  "------------------------------------------------------------------------------------\r\n");
fwrite($Saved_File, "$dataServer - $nomeFilePhp - " . print_r($_GET, true) . "\r\n");
fclose($Saved_File);

/* inizializzo le variabili */
$dataInizio = null;            // Se è questa variabile impostata, la query parte dalle rivelazioni effettuate da questa data, altrimenti parte da 30 giorno fa
$dataInizio = null;            // Se è questa variabile impostata, la query arriva alle rivelazioni effettuate fino a questa data, altrimenti arriva fino ad oggi
$pressioneBMP = 0;            // Se è questa variabile è impostata a 1 allora viene visualizzato il grafico con le rilevazioni della pressione atmosferica fatte dal sendore BMP180

$urlToGetJasonData = "getData/getJsonDataFromDb.php?pressioneBMP=1";

/* recupero le variabili dalla richiesta */
if (isset($_GET['dataInizio'])) {
	$dataInizio = htmlspecialchars($_GET["dataInizio"]);
	$urlToGetJasonData .= "&dataInizio=$dataInizio";
// 	echo "dataInizio=$dataInizio";
} else {
	// imposto la data di 7 giorni fa
	$dataInizio = date("Y-m-d", strtotime('-7 days'));
}
if (isset($_GET['dataFine'])) {
	$dataFine = htmlspecialchars($_GET["dataFine"]);
	$urlToGetJasonData .= "&dataFine=$dataFine";
// 	echo "dataFine=$dataFine";
} else {
	// imposto la data di oggi
	$dataFine = date("Y-m-d");
}
if (isset($_GET['pressioneBMP'])) {
	$pressioneBMP = htmlspecialchars($_GET["pressioneBMP"]);
	$urlToGetJasonData .= "&pressioneBMP=$pressioneBMP";
}


// Se non è impostato nessun sensore ne imposto uno in modo che sia visualizzato almeno un grafico
if ( $pressioneBMP!=1 ) {
	$pressioneBMP = 1;
}

// Imposto le date per fare alcune prove
// poi devo ricordarmi di eliminare queste impostazioni!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// $dataInizio = "2016-03-04";
$urlToGetJasonData .= "&dataInizio=$dataInizio";
// $dataFine = "2016-03-05";
$urlToGetJasonData .= "&dataFine=$dataFine";

?>


<!--Load the AJAX API-->
    <script type="text/javascript" src="https://www.google.com/jsapi"></script>
    
        <script type="text/javascript">
    	google.load('visualization', '1', {'packages':['corechart']});
      google.setOnLoadCallback(drawChart);


      function drawChart() {
      
        var jsonData = $.ajax({
          url: "<?=$urlToGetJasonData ?>",
          dataType: "json",
          async: false
          }).responseText;
          
        // Create our data table out of JSON data loaded from server.
        var data = new google.visualization.DataTable(jsonData);

        var options = {
          title: 'Informazioni pressione atmosferica casa',
          curveType: 'function',
          legend: { position: 'right' },
          interpolateNulls: true,
          width: '100%',
          height: 500,
          backgroundColor: 'transparent'
        };
     	// backgroundColor: 'rgb(255,0,0)'
     	// backgroundColor: 'transparent'
// 		backgroundColor: {
// 	          'fill': '#FFFFFF',
// 	          'opacity': 50
// 		  }
		  
		// Instantiate and draw our chart, passing in some options.
      var chart = new google.visualization.LineChart(document.getElementById('curve_chart'));

        chart.draw(data, options);
      
      } // drawChart()
      
      $(window).resize(function(){
    	  drawChart();
    	  console.log("Lancio drawChart()");
      });
    </script>
    
    
    <!--  <div id="curve_chart" style="width: 900px; height: 500px"></div> --> 
    
		<div class="contenitoreChart">
   			<div id="curve_chart" ></div>
		</div>

    
    
<form id="histTempForm" name="histTempForm" class="form-horizontal" role="form" method="get" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF']); ?>">

	<input type="hidden" name="page" value="<?php echo $_GET["page"]; ?>">

	<!-- Il campo input type="date" di html5 non è supportato da IE e Firefox, lo supportano Chrome, Safari e Opera.
		 Potrei integrarlo con il Datepicker di jqueryui
		 ma diventa un po' noisa la doppia gestione, soprattutto per i differenti controlli sulla data.
		 Di IE non mi importa niente,
		 per Firefox c'è un bug aperto:
		 https://support.mozilla.org/it/questions/994340
		 Comunque per farlo funzionare ho importato modernizr e polyfiller
		 ma non mi sembra che funzioni tutto bene
	 -->
	 
<br>
<hr class="dropdown-divider">
<br>
	 
 	<div class="form-group row">
    	<label for="dataInizio" class="col-sm-2 form-control-label">Data di inizio</label>
    	<div class="col-sm-3">
    		<input type="date" class="form-control col-sm-2 " id="dataInizio" name="dataInizio" value="<?php echo $dataInizio; ?>" placeholder="gg/mm/aaaa">
    		<!-- <small class="text-muted">Data di inizio.</small> -->
    	</div>
   	</div>
  	<div class="form-group row">
    	<label for="dataFine" class="col-sm-2 form-control-label">Data di fine</label>
    	<div class="col-sm-3">
    		<input type="date" class="form-control col-sm-2 " id="dataFine" name="dataFine" value="<?php echo $dataFine; ?>" placeholder="gg/mm/aaaa">
    		<!-- <small class="text-muted">Data di fine.</small> -->
    	</div>
  	</div>

	
 	<div class="form-group row">
    	<div class="col-sm-offset-2 col-sm-3">  
			<button type="submit" class="btn btn-primary" value="Submit">Invia</button>
			<!--  <button type="reset" class="btn btn-primary" value="Reset">Reset</button> -->
			<input type="button" class="btn btn-primary" name="clear" value="Reset" onclick="clearForm(this.form);">
		</div>
	</div>
</form>








