print("run.lua - inizio")

package.loaded.configurations      = nil
connectionFunctions                = nil
local configurationsModule      = require "configurations"
local connectionFunctionsModule = require "connectionFunctions"

-- configurazione schermo LCD
-- i2c.setup(id, pinSDA, pinSCL, speed)
print("run.lua - setup LCD")
i2c.setup(0, pinSDA, pinSCL, i2c.SLOW)
lcd = dofile("lcd1602.lc")()
print("run.lua - Prima scritta LCD")
lcd.put(lcd.locate(0, 2), "Ciao Ludo :)")
tmr.delay(1000000) -- 1 secondo
dht22result = dofile("dht22.lc")()
--lcd.put(lcd.locate(1, 0), "T: "..dht22result.temp.."  U: "..dht22result.humi)

package.loaded.connectToWifi       = nil
local connectToWifiModule       = require "connectToWifi"

--dht22result = dofile("dht22.lc")()
--lcd.put(lcd.locate(0, 0), "T: "..dht22result.temp.."  U: "..dht22result.humi)

lcd.put(lcd.locate(0, 0), "idDispositivo: " .. idDispositivo) 
--tmr.delay(2000000) -- 1 secondo

-- Serve per visualizzare un punto lampeggiante in fondo a destra nello schermo LCD
countPoint = 0
-- Serve per inviare al server i dati non ad ogni lettura ma ogni x letture
-- Se le letture avvengono ogni 30 secondi e invio i dati ogni 20 cicli allora li invio ogni 10 minuti
countSend = 1

-- 30.000ms = 30 sec
tmr.alarm( 4, 30000, 1, function()
    print("run.lua - ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")
    dht11result = dofile("dht11.lc")()
    --print("run.lua - dht11temp= "..dht11result.temp.." - dht11humi= "..dht11result.humi)
    
    dht22result = dofile("dht22.lc")()
    --print("run.lua - dht22temp= "..dht22result.temp.." - dht22humi= "..dht22result.humi)
    
    lcd.clear()
    --temp11str = aggiungiDecimale(dht11result.temp)
    --humi11str = aggiungiDecimale(dht11result.humi)
    temp11str = dht11result.temp
    humi11str = dht11result.humi
    temp22str = aggiungiDecimale(dht22result.temp)
    humi22str = aggiungiDecimale(dht22result.humi)

    print("run.lua -------------")
    print("run.lua - dht11temp= "..temp11str.." - dht11humi= "..humi11str)
    print("run.lua - dht22temp= "..temp22str.." - dht22humi= "..humi22str)
    
    lcd.put(lcd.locate(0, 0), "Temp.: " .. temp22str .. " *C")
    lcd.put(lcd.locate(1, 0), "Umid.: " .. humi22str .. " %")
    
    if ( countPoint == 0 ) then
        lcd.put(lcd.locate(1, 15), ".")
 	     countPoint = 1
    else
 	     countPoint = 0
    end     

    if ( countSend >= 20 ) then
        lcd.put(lcd.locate(1, 0), "Sending data....")
        sendDataToServer(idDispositivo, temp22str, humi22str)
        countSend = 0
    else
        countSend = countSend +1
    end     
    

    --tmr.stop(4)
end)

-- prende in input un numero che potrebbe avere il punto decimale oppure no
-- traforma il numero in stringa
-- se non c'è il punto decimale aggiunge alla fine della stringa ".0"
-- e restituisce la stringa
function aggiungiDecimale(numero)
    --print ('run.lua - ')
    numeroStr = tostring(numero)
    -- string.find (str, pattern, index, plain)
    inizio, fine = string.find( numeroStr, ".", 1, true )
    if ( inizio == nil ) then 
        --print ('run.lua - non ho trovato il punto nel numero=')
        numeroStr = numeroStr .. ".0"
    end
    --print ('run.lua - numero=' .. numero .. ' - numeroStr=' .. numeroStr )
    return numeroStr
end


-- configuro i parametri per la connessione all'Arduino collegato al sistema di allarme
--ipArduinoAlarm = '192.168.10.151'









-- comandi utili:
-- print("****************************************")
-- print("DHT11", dofile("dht22b.lua").read(pindht11))
-- print("DHT22", dofile("dht22b.lua").read(pindht22, true))

-- dofile("run.lc")
-- dofile("run.lua")
